//

#if !defined(AFX_FASTCAMMONITORDLG_H__F0489630_97AB_4503_B056_2FB51C655ADC__INCLUDED_)
#define AFX_FASTCAMMONITORDLG_H__F0489630_97AB_4503_B056_2FB51C655ADC__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CameraControl.h"
#include "ImageData.h"

#define	MAX_PARAM_LIST LIST_MAX_NUMBER
#define TIMER_MODE_LIVE 1000

/////////////////////////////////////////////////////////////////////////////

class CFastCamMonitorDlg : public CDialog
{
// construct
public:
	CFastCamMonitorDlg(CWnd* pParent = NULL);	

	//{{AFX_DATA(CFastCamMonitorDlg)
	enum { IDD = IDD_FASTCAMMONITOR_DIALOG };
	CStatic	m_device_name;
	CStatic	m_rectMovieRange;
	CStatic	m_disp_status2;
	CStatic	m_disp_status1;
	CStatic	m_disp_trigmode;
	CStatic	m_disp_gain;
	CStatic	m_disp_shutterspeed;
	CStatic	m_disp_resolution;
	CComboBox	m_change_rate;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CFastCamMonitorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

protected:
	HICON	m_hIcon;

	//{{AFX_MSG(CFastCamMonitorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnPrpgramExit();
	afx_msg void OnLiveImageStop();
	afx_msg void OnLiveImageDisp();
	afx_msg void OnVersionInf();
	afx_msg void OnSelchangeChangeRate();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CCameraControl *m_cameraControl;

	CImageData *m_ImageData;

	BOOL	m_Execute_Live;		
	BOOL	m_Execute_Record;	
	int		m_nRecordRate;		
	double	m_dRecordTime;		
	int		m_nShutterSpeed;	
	int		m_nTrigMode;	
	int		m_dwResolution;	
	int		m_nGain;			
	int		m_Width;			
	int		m_Height;		
	
	LPBITMAPINFO		m_BmpInfo;			
	BITMAPFILEHEADER	m_BmpFileHdr;	
	BITMAPINFOHEADER	m_BmpInfoHdr;		
	RGBQUAD				m_BmpRgbQuad[256];	
	FILE				*m_pBmpFp;		
	char*				m_BmpImage;			
	int					m_gnSizeFileHdr;	
	int					m_gnSizeInfoHdr;	
	int					m_gnSizeInfo;		
	int					m_gnSizeRgbQuad;	
	int					m_gnSizeTop;		
	int					m_gnSizeBmpImage;	
	char				m_gszWkBuf[1280*3];	

	CAMERA_PARAMS		m_CameraParams;

	BOOL				m_IsDraw;	

private:
	void DspLiveCamera();
	int	 GetParameterList(int nNo);
	int	 GetParameter(int nNo);
	int	 SetParameter(int nNo);
	void UpdateParam();
	void UpdateMovieRangeWindow();
	void ClearMovieRangeWindow();
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_FASTCAMMONITORDLG_H__F0489630_97AB_4503_B056_2FB51C655ADC__INCLUDED_)
