///////////////////////////////////////////
/// CCameraControl Class
///////////////////////////////////////////

#if !defined(CAMERACONTROL_H__0_0_0_0_0__INCLUDED_)
#define CAMERACONTROL_H__0_0_0_0_0__INCLUDED_

#if !defined(PCCLIB_API)

#if PCCLIB_EXPORTS
#define PCCLIB_API __declspec(dllexport)
#else
#define PCCLIB_API
#endif

#endif

#include	<windows.h>
#include	"ConstantValues.h"
#include	"IrigLib.h"

typedef long (__stdcall *HOGE) (DWORD, DWORD, DWORD, DWORD, DWORD);

#define		LIST_MAX_NUMBER			128
#define		PARTITION_MAX_NUMBER	256
#define		PCCLIB_VERSION			2981
#define		LIST_MAX_NUMBER_EX		256

//Camera Params
typedef struct {
		BOOL			enable_random_trigger;
		BOOL			enable_manual_trigger;
		BOOL			enable_random_manual;
		BOOL			enable_gamma;
		BOOL			enable_gain;
		BOOL			enable_external_sync;	//same as enable_external_sync_in
		BOOL			enable_external_sync_in;
		BOOL			enable_external_sync_out;
		BOOL			enable_external_in;
		BOOL			enable_external_out;
		BOOL			enable_color_temp;

		char			camera_type[64];
		char			device_name[64];
		int				device_type;
		int				device_version;
		int				color;
		int				session_number;
		int				max_frame_num;

		int				camera_mode;
		BOOL			is_live;
		BOOL			is_record_ready;

		int				record_rate;
		DWORD			resolution;
		int				shutter_speed;
		int				trigger_mode;
		int				trigger_frame;
		int				random_trigger_num;
		int				manual_trigger_frame;
		int				random_trigger_times;
		int				max_random_times;	//random-center and random-manual only 
		int				random_manual_frame;
		int				twostage_lowtohigh_frame;
		int				twostage_hightolow_frame;
		int				twostage_lowtohigh_timing;
		int				gamma_value;
		int				gain_level;
		BOOL			external_sync;	//same as external_sync_in
		BOOL			external_sync_nega;	//same as external_sync_in
		int				color_temp_mode;
		int				external_sync_in;
		int				external_sync_out;

		int				record_rate_num;
		int				resolution_num;
		int				shutter_num;
		int				trigger_mode_num;
		int				random_number_num;
		int				external_in_num;
		int				external_out_num;
		int				color_temp_mode_num;
		int				color_temp_user_num;
		int				gain_level_num;	
		int				gamma_value_num;

		int				record_rate_list[LIST_MAX_NUMBER];
		DWORD			resolution_list[LIST_MAX_NUMBER];
		int				shutter_list[LIST_MAX_NUMBER];
		int				trigger_mode_list[LIST_MAX_NUMBER];
		int				random_number_list[LIST_MAX_NUMBER];
		int				external_in[LIST_MAX_NUMBER];
		int				external_out[LIST_MAX_NUMBER];
		int				color_temp_mode_list[LIST_MAX_NUMBER];
		int				color_temp_user[LIST_MAX_NUMBER][3];
		int				gain_level_list[LIST_MAX_NUMBER];
		int				gamma_value_list[LIST_MAX_NUMBER];

		BOOL			enable_mcdl;
		BOOL			enable_monitor_out;
		BOOL			enable_monitor_out_mode;
		BOOL			enable_monitor_edge;
		BOOL			enable_monitor_zoom;
		BOOL			enable_irig;
		BOOL			enable_restriction_time;

		BOOL			monitor_block_on;
		int				monitor_block_start;
		int				monitor_block_end;
		int				monitor_play_rate;
		int				monitor_out_mode;
		int				monitor_edge_mode;
		BOOL			monitor_zoom_on;
		BOOL			mcdl_on;
		BOOL			irig_on;
		BOOL			restriction_time_on;

		BOOL			exist_variablefunc;
		int				variable_channel;
		int				save_step;
} CAMERA_PARAMS;

//Extra Camera Params
typedef struct {
		BOOL			exist_mcdl;
		BOOL			exist_monitor_out;
		BOOL			exist_monitor_out_mode;
		BOOL			exist_monitor_edge;
		BOOL			exist_monitor_zoom;
		BOOL			exist_irig;
		BOOL			exist_restriction_time;
		BOOL			exist_pdc;
		BOOL			exist_device_id;
		BOOL			exist_reset_trigger;
		BOOL			exist_sensor_bitshift;
		BOOL			exist_partition;
		BOOL			exist_geometric_conversion;
		BOOL			exist_shading_compensation;
		BOOL			exist_live_resolution;
		BOOL			exist_lut_mode;
		BOOL			exist_user_lut;
		BOOL			exist_chroma_mode;
		BOOL			exist_ds_shutter;

		BOOL			monitor_block_on;
		int				monitor_block_start;
		int				monitor_block_end;
		int				monitor_play_rate;
		int				monitor_out_mode;
		int				monitor_edge_mode;
		BOOL			monitor_zoom_on;
		BOOL			mcdl_on;
		BOOL			irig_on;
		BOOL			restriction_time_on;
		BOOL			pdc_on;
		int				device_id;
		BOOL			reset_trigger_on;
		int				sensor_bitshift;
		int				max_partition_num;
		int				max_partition_block_num;
		int				partition_frame_per_block;
		int				current_partition;
		int				partition_num;
		int				partition_size_list[PARTITION_MAX_NUMBER];
		int				geometric_conversion_mode;
		int				shading_compensation_mode;
		int				live_resolution_mode;
		int				lut_mode;
		int				chroma_mode;
		int				ds_shutter;
		int				irig_offset;

		BOOL			exist_irig_offset;
		BOOL			exist_hard_partition;
		BOOL			hard_partition;

		BOOL			II_power_on;
		DWORD			II_gain;
		DWORD			II_gate_select;
		DWORD			II_gate_cycle;
		DWORD			II_gate_width;
		DWORD			II_gate_times;
		DWORD			II_gate_delay;
		DWORD			II_gain_limit;
		DWORD			II_gate_width_limit;
		BOOL			exist_ii;

		BOOL			shutter_mode;
		BOOL			exist_shutter_mode;

		BOOL			exist_event_frame;
		int				head_total_num;
		int				current_head;

		BOOL			exist_edge_enhancement;
		int				edge_enhancement;

		BOOL			exist_shutter_type2;
		int				shutter_type2_list[LIST_MAX_NUMBER];
		int				shutter_speed_type2;
		int				color_matrix_rr;
		int				color_matrix_rg;
		int				color_matrix_rb;
		int				color_matrix_gr;
		int				color_matrix_gg;
		int				color_matrix_gb;
		int				color_matrix_br;
		int				color_matrix_bg;
		int				color_matrix_bb;
		BOOL			exist_color_matrix;
		BOOL			color_matrix;

		BOOL			exist_auto_exposure;
		int				auto_exposure;
		int				auto_exposure_reso;
		int				auto_exposure_pos;
		int				auto_exposure_value;
		int				auto_exposure_range;
		int				auto_exposure_maxshutter;

		BOOL			exist_ii_protection;
		DWORD			II_protection;
} CAMERA_PARAMS_EX;

//Frame Params
typedef struct {
		int				start;
		int				end;
		int				total;
		int				area_start;
		int				area_end;
		int				area_total;
		int				current;
		int				trigger;
		int				key;
} FRAME_PARAMS;

//Time Params
typedef struct {
		double			start;
		double			end;
		double			total;
		double			area_start;
		double			area_end;
		double			area_total;
		double			current;
		double			trigger;
		double			key;
} TIME_PARAMS;

//MCDL
typedef struct {
		unsigned char	digital[10];
		float			analog_a[10];
		float			analog_b[10];
		float			analog_c[10];
		float			analog_d[10];
} MCDL_PARAMS;

//Extra Function
enum {
	EXTRA_SET_MONITOROUT_MODE = 0,
	EXTRA_GET_MONITOROUT_MODE,
	EXTRA_SET_MONITOROUT_EDGEENHANCE,
	EXTRA_GET_MONITOROUT_EDGEENHANCE,
	EXTRA_SET_MONITOROUT_ZOOM,
	EXTRA_GET_MONITOROUT_ZOOM,
	EXTRA_SET_MONITOROUT_DISP_STATUS,
	EXTRA_GET_MONITOROUT_DISP_STATUS,
	EXTRA_MONITOROUT_PLAY,
	EXTRA_MONITOROUT_PAUSE,
	EXTRA_MONITOROUT_STOP,
	EXTRA_MONITOROUT_STEP_FOWARD,
	EXTRA_MONITOROUT_STEP_BACK,
	EXTRA_MONITOROUT_GOTO_ANYFRAME,
	EXTRA_MONITOROUT_GOTO_STARY,
	EXTRA_MONITOROUT_GOTO_END,
	EXTRA_MONITOROUT_GOTO_TRIGGER,
	EXTRA_SET_ENABLE_MCDL,
	EXTRA_GET_ENABLE_MCDL,
	EXTRA_SET_ENABLE_IRIG,
	EXTRA_GET_ENABLE_IRIG,
	EXTRA_SET_ENABLE_PDC,
	EXTRA_GET_ENABLE_PDC,
	EXTRA_SET_ENABLE_RESTRICTION_TIME,
	EXTRA_GET_ENABLE_RESTRICTION_TIME,
	EXTRA_GET_RESTRICTION_TIME,
	EXTRA_TRANSFER_MCDL,
	EXTRA_TRANSFER_IRIG,
	EXTRA_SHADING_COMPENSATION,
	EXTRA_GET_CAMERA_ID,
	EXTRA_SET_CAMERA_ID,
	EXTRA_GET_ENABLE_RESET_TRIGGER,
	EXTRA_SET_ENABLE_RESET_TRIGGER,
	EXTRA_GET_SENSOR_BITSHIFT,
	EXTRA_SET_SENSOR_BITSHIFT,
	EXTRA_GET_MAX_PARTITION,
	EXTRA_GET_PARTITION,
	EXTRA_SET_PARTITION,
	EXTRA_GET_PARTITION_LIST,
	EXTRA_SET_PARTITION_LIST,
	EXTRA_SET_LIVE_RESOLUTION,
	EXTRA_GET_LIVE_RESOLUTION,
	EXTRA_SET_LUT_MODE,
	EXTRA_GET_LUT_MODE,
	EXTRA_SET_USER_LUT_PARAMS,
	EXTRA_GET_USER_LUT_PARAMS,
	EXTRA_SET_USER_LUT_DATA,
	EXTRA_GET_USER_LUT_DATA,
	EXTRA_UPLOAD_USER_LUT,
	EXTRA_SET_CHROMA_MODE,
	EXTRA_GET_CHROMA_MODE,
	EXTRA_SET_DS_SHUTTER_MODE,
	EXTRA_GET_DS_SHUTTER_MODE,
	EXTRA_SET_INTERFACE_INFO,
	EXTRA_GET_INTERFACE_INFO,
	EXTRA_SET_SHADING_MODE,
	EXTRA_GET_SHADING_MODE,
	EXTRA_GET_SHADING_LOCK,
	EXTRA_TRANSFER_MCDLIRIG_STREAM,
	EXTRA_SET_IRIG_OFFSET,
	EXTRA_GET_IRIG_OFFSET,
	EXTRA_SET_HARD_PARTITION,
	EXTRA_GET_HARD_PARTITION,
	EXTRA_GET_HEAD_INFO,
	EXTRA_GET_HEAD_EXCHANGE,
	EXTRA_SET_HEAD_EXCHANGE,
	EXTRA_SET_SHUTTER_MODE,
	EXTRA_GET_SHUTTER_MODE,
	EXTRA_SET_II_POWER,
	EXTRA_GET_II_POWER,
	EXTRA_SET_II_GAIN,
	EXTRA_GET_II_GAIN,
	EXTRA_SET_II_GATE_SELECT,
	EXTRA_GET_II_GATE_SELECT,
	EXTRA_SET_II_GATE_CYCLE,
	EXTRA_GET_II_GATE_CYCLE,
	EXTRA_SET_II_GATE_WIDTH,
	EXTRA_GET_II_GATE_WIDTH,
	EXTRA_SET_II_GATE_TIMES,
	EXTRA_GET_II_GATE_TIMES,
	EXTRA_SET_II_GATE_DELAY,
	EXTRA_GET_II_GATE_DELAY,
	EXTRA_GET_II_GAIN_LIMIT,
	EXTRA_SET_TRANSFER_CACHE,
	EXTRA_GET_EVENT_FRAME,
	EXTRA_SET_VARIABLE_SAVE,
	EXTRA_SET_VARIABLE_LOAD,
	EXTRA_SET_VARIABLE_ERASE,
	EXTRA_GET_II_GATE_WIDTH_LIMIT,
	EXTRA_SET_PIXEL_GAIN,
	EXTRA_GET_PIXEL_GAIN,
	EXTRA_SET_EDGE_ENHANCEMENT,
	EXTRA_GET_EDGE_ENHANCEMENT,
	EXTRA_SET_COLOR_MATRIX,
	EXTRA_GET_COLOR_MATRIX,
	EXTRA_SET_AUTO_EXPOSURE,
	EXTRA_GET_AUTO_EXPOSURE,
	EXTRA_SET_AUTO_EXPOSURE_MAXSHUTTER,
	EXTRA_GET_AUTO_EXPOSURE_MAXSHUTTER,
	EXTRA_GET_1FRAME_TIME,
	EXTRA_SET_II_PROTECTION,
	EXTRA_GET_II_PROTECTION,
};

class PCCLIB_API CCameraControl
{
public:
	CCameraControl(int device_select = DEVICE_SELECT_AUTO);
	virtual			~CCameraControl();

	int				Init(int camera_num);
	int				Exit();
	int				IsInit();

	int				GetFrameParams(FRAME_PARAMS &params);

	int				SetCameraParams(CAMERA_PARAMS params);
	int				GetCameraParams(CAMERA_PARAMS &params);
	int				UpdateCameraParams();

	int				SetCameraParamsEx(CAMERA_PARAMS_EX params);
	int				GetCameraParamsEx(CAMERA_PARAMS_EX &params);
	int				UpdateCameraParamsEx();
	
	int				GetBufferAddress(BYTE * buff);
	int				GetNumberOfDevice(int & num);
	int				GetMaxFrame(int & max);
	int				GetDeviceName(LPTSTR name);
	int				GetDeviceType(int &type);
	int				GetDeviceVersion(int &version);

	int				SetRecordRate(int rate);
	int				SetShutterSpeed(int mode);
	int				SetTriggerMode(int mode);
	int				SetRandomTriggerNumber(int number);
	int				SetRandomTriggerTimes(int times);
	int				SetManualTriggerPosition(int position);
	int				SetRandomManualPosition(int position);
	int				SetResolution(DWORD resolution);
	int				SetGammaCorrection(int value);
	int				SetGainLevel(int level);
	int				SetSessionNumber(int number);
	int				SetExternalSyncMode(BOOL on);
	int				SetColorTemperature(int mode);
	int				SetColorTempUser(int mode, int r, int g, int b);
	int				SetEdgeEnhancementMode(int mode);
	int				SetZoomMode(BOOL on);

	int				GetRecordRate(int &rate);
	int				GetShutterSpeed(int &speed);
	int				GetShutterSpeedType2(int &speed);
	int				GetTriggerMode(int &mode);
	int				GetRandomTriggerNumber(int &number);
	int				GetRandomTriggerTimes(int &times);
	int				GetMaxRandomTimes(int &max);
	int				GetManualTriggerPosition(int &position);
	int				GetRandomManualPosition(int &position);
	int				GetTwoStageTriggerInfo(int &lowtohigh_frame, int &hightolow_frame, int &lowtohigh_timing);
	int				GetResolution(DWORD &resolution);
	int				GetGammaCorrection(int &value);
	int				GetGainLevel(int &level);
	int				GetSessionNumber(int &number);
	int				GetExternalSyncMode(BOOL &on);
	int				GetColorTemperature(int &mode);
	int				GetColorTempUser(int mode, int &r, int &g, int &b);
	int				GetEdgeEnhancementMode(int &mode);
	int				GetZoomMode(BOOL &on);

	int				GetEnableMCDL(BOOL &enable);
	int				SetEnableMCDL(BOOL enable);

	int				OnLive(BOOL on);
	int				OnRecordReady(BOOL on);
	int				OnRecord(BOOL on);
	int				TriggerIn();

	int				GetCameraMode(int &mode);
	int				IsLive(BOOL &on);
	int				IsRecordReady(BOOL &on);
	int				IsRecord(BOOL &on);
	int				IsEndressRec(BOOL &on);
	int				IsColor(BOOL &color);

	int				HaveGammaCorrection(BOOL &have);
	int				HaveGainLevel(BOOL &have);
	int				HaveColorTemperature(BOOL &have);
	int				HaveExternalSyncMode(BOOL &have);
	int				HaveExternalSyncInMode(BOOL &have);
	int				HaveExternalSyncOutMode(BOOL &have);
	int				HaveExternalInput(BOOL &have);
	int				HaveExternalOutput(BOOL &have);
	int				HaveEdgeEnhancement(BOOL &have);
	int				HaveZoomMode(BOOL &have);
	int				HaveBlockPlay(BOOL &have);
	int				HaveMCDL(BOOL &have);

	int				GetRecordRateList(int * list, int listsize);
	int				GetShutterSpeedList(int * list, int listsize);	
	int				GetResolutionList(DWORD * list, int listsize);
	int				GetTriggerModeList(int * list, int listsize);
	int				GetRandomTriggerNumberList(int * list, int listsize);
	int				GetColorTemperatureList(int * list, int listsize);
	int				GetGainLevelList(int * list, int listsize);
	int				GetGammaCorrectionList(int * list, int listsize);
	int				GetShutterSpeedType2List(int * list, int listsize);
	int				GetShutterSpeedAEList(int * list, int listsize, int * listnum);

	int				TransferFrame(int frame, BYTE * buff);
	int				TransferMCDL(int frame, BYTE * buff);
	int				TransferIRIG(int frame, BYTE * buff);
	int				TransferMCDL(int frame, MCDL_PARAMS &mcdl);
	int				TransferIRIG(int frame, IRIGLIB_TIMECODE &irig);
	int				TransferRawBayer(int frame, BYTE * buff);
	int				Transfer16BitFrame(int frame, WORD * buff);
	int				Transfer16BitRawBayer(int frame, WORD * buff);

	int				SetExternalSyncModeEx(int mode);
	int				GetExternalSyncModeEx(int &mode);

	int				SetExternalSyncInMode(int mode);
	int				GetExternalSyncInMode(int &mode);
	int				SetExternalSyncOutMode(int mode);
	int				GetExternalSyncOutMode(int &mode);

	int				SetExternalInMode(int port, int mode);
	int				GetExternalInMode(int port, int &mode);
	int				SetExternalOutMode(int port, int mode);
	int				GetExternalOutMode(int port, int &mode);

	int				ShadingCompensation();

	int				HaveMonitorOutMode(BOOL &have);
	int				SetMonitorOutMode(int mode);
	int				GetMonitorOutMode(int &mode);

	int				Play(int mode);
	int				Pause(BOOL on);
	int				Stop();
	int				StepFoward();
	int				StepBack();
	int				GoAnyFrame(int frame);
	int				GoStart();
	int				GoEnd();
	int				GoTrigger();

	int				SetPlayRate(int rate);
	int				SetBlockArea(int start, int end);
	int				SetBlockMode(BOOL on);

	int				GetPlayRate(int &rate);
	int				GetBlockArea(int& start, int& end);
	int				GetBlockMode(BOOL& on);

	int				HaveIRIG(BOOL &have);
	int				SetEnableIRIG(BOOL enable);
	int				GetEnableIRIG(BOOL &enable);
	int				GetTimeCodeFromFrame(IRIGLIB_TIMECODE &time_code, int frame, int timeocde_mode = TIMECODE_IRIG);
	int				GetCapturedIRIGTime(IRIGLIB_TIMECODE &time_code);

	int				GetDateOfRecording(int& year, int& month, int& day);
	int				GetTimeOfRecording(int& hour, int& minute, int& second);

	int				SetFrame(int frame);
	int				GetFrame(int &frame);

	int				SetEnableRestrictionTime(BOOL enable);
	int				GetEnableRestrictionTime(BOOL &enable);
	int				GetRestrictionTime(int &time, int &rest_time);

	int				SendCommand(DWORD command, LPVOID param1, LPVOID param2, LPVOID param3, DWORD &ret);
	int				ExtraCommand(DWORD command, DWORD param1, DWORD param2 = 0, DWORD param3 = 0, DWORD param4 = 0);

	int				GetPartitionInfo(int &max_partition, int &max_partition_block, int &frame_per_block);
	int				GetPartition(int &partition);
	int				SetPartition(int partition);
	int				GetPartitionBlockList(int * list, int listsize);
	int				SetPartitionBlockList(int * list, int listsize);

	int				SetGeometricConvert(int mode);
	int				GetGeometricConvert(int &mode);

	int				GetInterfaceType(int &type);

	void			ConvertIrig60secTo0sec(IRIGLIB_TIMECODE &time_code, int offset);

	int				GetRandCenterManualFrames(int &Times, int &frame);

	void			GetIICycleRange(DWORD* dwMin, DWORD* dwMax);
	void			GetIIWidthRange(DWORD* dwMin, DWORD* dwMax);
	void			GetIIDelayRange(DWORD* dwMin, DWORD* dwMax);
	void			GetIITimesRange(DWORD* dwMin, DWORD* dwMax);
	void			SetIIPowerSafetyParam(int nBaseValue, DWORD *pValue, DWORD nMode, DWORD nEnable);
	void			GetVSensorPosition(DWORD* nPosX, DWORD* nPosY);

	int				GetHeadName(LPTSTR name, int no);
	int				GetVariableRateList(int * list, int listsize);
	int				GetVariableMaxResolution(int nFrame, int * nWidth, int * nHeight);
	int				GetVariableMaxWidth(int nFrame, int nHeight, int * nWidth);
	int				GetVariableMaxHeight(int nFrame, int nWidth, int * nHeight);
	int				GetVariableMaxFrameRate(int nWidth, int nHeight, int * nRate);
	int				GetVariableSetting(int nChannel, int * nFrameRate, int * nWidth, int * nHeight, int * nXPos, int * nYPos);
	int				SetVariableSetting(int nChannel, int nFrameRate, int nWidth, int nHeight, int nXPos, int nYPos);
	int				GetVariableCamMode(int * nMode, int * nChannel);
	int				CreatePixelGain(WORD* list);
	int				TransferFrameUseGain(WORD* buff);
	int				GetPixelGainParam(WORD* list);
	int				SetPixelGainParam(WORD* list);
	int				GetShadingParam(WORD* list);
	int				SetPixelGainParamDefault(WORD* list);
	int				SetShadingParamDefault(WORD* list);
	int				GetColorMatrixParam(int plane, int* r, int* g, int* b);

	int				SetAutoExposure(int nWidth, int nHeight, int nXPos, int nYPos, int nValue, int nRange);
	int				GetAutoExposureArea(int * nWidth, int * nHeight, int * nXPos, int * nYPos);
	int				GetAutoExposureParam(int * nValue, int * nRange);

	int				SetGEtherConfig(DWORD PacketSize, DWORD SendPort, DWORD ReceivePort, DWORD ConnectMode);
	int				GetGEtherConfig(DWORD* PacketSize, DWORD* SendPort, DWORD* ReceivePort, DWORD* ConnectMode);
private:
	void			UpdateTriggerFrame();
	int				InnerToDeviceFrame(int frame);
	int				DeviceToInnerFrame(int frame);

private:
	HINSTANCE			m_hLibrary;
	HOGE				m_pCameraFunc;

	int					m_nLoadedLibType;
	int					m_nCameraNumber;
	int					m_nMaxCameraNumber;

	CAMERA_PARAMS*		m_cpParams;
	CAMERA_PARAMS_EX*	m_cpParamsEx;	
	FRAME_PARAMS		m_fpInner;
	BOOL				m_bInitDll;
	BOOL				m_bInit;
	BOOL				m_bReferenceCameraParams;

	IRIGLIB_TIMECODE	m_irigTimeCode;
	MCDL_PARAMS			m_Mcdl;
	BOOL				m_bEnableIrigLib;
};

#endif
