#include "stdafx.h"
#include "FastCamMonitor.h"
#include "FastCamMonitorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); 
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////////
// CFastCamMonitorDlg 
/////////////////////////////////////////////////////////////////////////////////////////////////
CFastCamMonitorDlg::CFastCamMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFastCamMonitorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFastCamMonitorDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_BmpInfo = NULL;
	m_BmpImage = NULL;
	m_nRecFrame = 0;
}

void CFastCamMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFastCamMonitorDlg)
	DDX_Control(pDX, IDC_DEVICE_NAME, m_device_name);
	DDX_Control(pDX, IDC_MOVIE_RANGE, m_rectMovieRange);
	DDX_Control(pDX, IDC_DISP_RECFRAME, m_disp_recframe);
	DDX_Control(pDX, IDC_DISP_STATUS2, m_disp_status2);
	DDX_Control(pDX, IDC_DISP_STATUS1, m_disp_status1);
	DDX_Control(pDX, IDC_DISP_TRIG, m_disp_trigmode);
	DDX_Control(pDX, IDC_DISP_GAIN, m_disp_gain);
	DDX_Control(pDX, IDC_DISP_SHUTTER, m_disp_shutterspeed);
	DDX_Control(pDX, IDC_DISP_DENSITY, m_disp_resolution);
	DDX_Control(pDX, IDC_CHANGE_RECORD, m_change_recordtime);
	DDX_Control(pDX, IDC_CHANGE_RATE, m_change_rate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFastCamMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CFastCamMonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_PRPGRAM_EXIT, OnPrpgramExit)
	ON_BN_CLICKED(IDC_PLAY_MEMORY, OnPlayMemory)
	ON_BN_CLICKED(IDC_LIVE_IMAGE_STOP, OnLiveImageStop)
	ON_BN_CLICKED(IDC_LIVE_IMAGE_DISP, OnLiveImageDisp)
	ON_BN_CLICKED(IDC_VERSION_INF, OnVersionInf)
	ON_BN_CLICKED(IDC_RECORD_SAVE_HD, OnRecordSaveHd)
	ON_BN_CLICKED(IDC_RECORD_MEMORY, OnRecordMemory)
	ON_CBN_SELCHANGE(IDC_CHANGE_RATE, OnSelchangeChangeRate)
	ON_CBN_SELCHANGE(IDC_CHANGE_RECORD, OnSelchangeChangeRecord)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//-----------------------------------------------------------------------------------------------
//	OnInitDialog()
//-----------------------------------------------------------------------------------------------
BOOL CFastCamMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		
	

	return TRUE;  
}

//-----------------------------------------------------------------------------------------------
//	OnSysCommand();
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//-----------------------------------------------------------------------------------------------
//	OnPaint();
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		UpdateMovieRangeWindow();
	}
}

void CFastCamMonitorDlg::UpdateMovieRangeWindow() 
{
	int			nCopyWidth;
	int			nCopyHeight;
	HBITMAP		myDIB;			
	HBITMAP		oldDIB;
	HDC			hDC;			
	HDC			hCompatiDC;		
	PAINTSTRUCT ps;				
	CString		msg;
	CRect		nRect;

	if(!m_BmpInfo)	return;

	CWnd* pMovieRangeWnd = GetDlgItem(IDC_MOVIE_RANGE);

	hDC = ::GetDC(*pMovieRangeWnd);

	::BeginPaint(*pMovieRangeWnd, &ps);

	hCompatiDC = ::CreateCompatibleDC(hDC);

	myDIB = ::CreateDIBitmap(hDC,&m_BmpInfo->bmiHeader,CBM_INIT,m_BmpImage,m_BmpInfo,DIB_RGB_COLORS);

	oldDIB = (HBITMAP)::SelectObject(hCompatiDC,myDIB);

	nCopyWidth  = m_BmpInfo->bmiHeader.biWidth;
	if(nCopyWidth>512)
		nCopyWidth = 512;
	nCopyHeight = m_BmpInfo->bmiHeader.biHeight;
	if(nCopyHeight>480)
		nCopyHeight = 480;
	::StretchBlt(hDC,0,0,nCopyWidth,nCopyHeight,hCompatiDC,0,nCopyHeight,nCopyWidth,-nCopyHeight,SRCCOPY);

	::EndPaint(*pMovieRangeWnd,&ps);

	::SelectObject(hCompatiDC, oldDIB);
	::DeleteObject(myDIB);
	::DeleteObject(hCompatiDC);
	::ReleaseDC(*pMovieRangeWnd,hDC);
}

void CFastCamMonitorDlg::ClearMovieRangeWindow() 
{
	CString		msg;
	CRect		nRect;
	CPoint		nLT;
	CPoint		nRB;
	DWORD		dwCol;

	CWnd* pMovieRangeWnd = GetDlgItem(IDC_MOVIE_RANGE);
	CClientDC	RangeCLDC(pMovieRangeWnd);

	pMovieRangeWnd->GetClientRect(nRect);

	nLT = nRect.TopLeft();
	nRB = nRect.BottomRight();
	nRB.x = nRB.x+1;
	nRect.SetRect(nLT.x, nLT.y, nRB.x, nRB.y);

	dwCol = GetSysColor(COLOR_BTNFACE);		
	RangeCLDC.FillSolidRect(nRect,dwCol);	
}

//-----------------------------------------------------------------------------------------------
//	OnQueryDragIcon();
//-----------------------------------------------------------------------------------------------
HCURSOR CFastCamMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//-----------------------------------------------------------------------------------------------
//	OnTimer(); 
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::OnTimer(UINT nIDEvent) 
{
	int		nSts;
	int		nRecFrame;
	double	dRecFrame;
	char	cWk0[10];
	BOOL	check;
	CString	msg;
	
	switch(nIDEvent){
	case TIMER_MODE_PLAY:
			if(!m_IsDraw)	DspPlayCamera();
			break;
	case TIMER_MODE_LIVE:
			if(!m_IsDraw)	DspLiveCamera();		
			break;
	case TIMER_MODE_RECORD:		

			if(m_Execute_Record==TRUE){

				m_cameraControl->IsRecord((BOOL &)check);
				if(check==FALSE){

					::KillTimer(GetSafeHwnd(), TIMER_MODE_RECORD);

					nSts = m_cameraControl->OnRecordReady(FALSE);
					if(nSts!=PCC_ERROR_NOERROR){
						msg = "error OnRecordReady";
						AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
						EndWaitCursor();	
						return;
					}
	
					dRecFrame = m_dRecordTime * m_nRecordRate;
					nRecFrame = (int)dRecFrame;
					sprintf(cWk0,"[%d]",nRecFrame);
					m_disp_recframe.SetWindowText(cWk0);
					m_nRecFrame = nRecFrame;	

					m_disp_status1.SetWindowText("End Record");

					msg = "End Record";
					AfxMessageBox(msg,MB_OK|MB_ICONINFORMATION);

					EndWaitCursor();		

					m_Execute_Record = FALSE;

					CButton* button1 = (CButton*)GetDlgItem(IDC_RECORD_SAVE_HD);
					button1->EnableWindow(TRUE);				
					CButton* button2 = (CButton*)GetDlgItem(IDC_PLAY_MEMORY);
					button2->EnableWindow(TRUE);				
					
					OnLiveImageDisp(); 
				}else{
					BeginWaitCursor();		
				}
			}
			break;
	}

	CDialog::OnTimer(nIDEvent);
}

//-----------------------------------------------------------------------------------------------
//	OnShowWindow();
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	int		nSts;
	int		nRet;
	int		nSel;
	int		nRecFrame;
	double	dRecFrame;
	CString ss;
	CString	msg;

	m_IsDraw=FALSE;	

	m_Width  = 512;
	m_Height = 480;

	m_Execute_Live	 = FALSE;
	m_Execute_Record = FALSE;	

	m_disp_status1.SetWindowText("Drawing stop");	

	m_cameraControl = new CCameraControl(0);

	nSts = m_cameraControl->Init(1);
	if(nSts==PCC_ERROR_NOERROR){
		
		char device_name[64];
		m_cameraControl->GetDeviceName(device_name);
		m_device_name.SetWindowText(device_name);
		
		nSts = GetParameterList(0);
		if(nSts<0){
			msg = "error GetRecordRateList";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
			return;
		}

		m_change_rate.GetLBText(3,ss);
		m_change_rate.SetWindowText(ss);
		m_change_rate.SetCurSel(3);	

		m_nRecordRate = atoi(ss);

		nRet = SetParameter(0);	
		if(nRet<0){
			msg = "error SetRecordRate";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
			return;
		}
		
		UpdateParam(); 	
	
		m_change_recordtime.ResetContent();
		m_change_recordtime.InsertString(-1,"0.5");
		m_change_recordtime.InsertString(-1,"1.0");
		m_change_recordtime.InsertString(-1,"1.5");
		m_change_recordtime.InsertString(-1,"2.0");
		m_change_recordtime.GetLBText(0,ss);
		m_change_recordtime.SetWindowText(ss);
		m_change_recordtime.SetCurSel(0);	

		nSel = m_change_recordtime.GetCurSel();
		m_change_recordtime.GetLBText(nSel,ss);
		m_dRecordTime = atof(ss);
		
		nSts = m_cameraControl->GetMaxFrame((int &)m_nMaxFrame);
		if(nSts==PCC_ERROR_NOERROR){
	
			nSel = m_change_recordtime.GetCurSel();
			m_change_recordtime.GetLBText(nSel,ss);

			m_dRecordTime = atof(ss);

			dRecFrame = m_dRecordTime * m_nRecordRate;
			nRecFrame = (int)dRecFrame;

			if(m_nMaxFrame<nRecFrame){
				msg = "shorten Play time";
				AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
			}
		}else{
			msg = "error GetMaxFrame";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		}
		
	}else{
		msg = "error Init";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);
	}
}

unsigned char buf[1280*1280*3];	

//-----------------------------------------------------------------------------------------------
//	DspLiveCamera();
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::DspLiveCamera()
{
	int		nRet;
	BOOL	check;
	CString	msg;

	m_IsDraw=TRUE;		

	nRet = m_cameraControl->IsColor((BOOL &)check);
	if(check==TRUE){
		if(m_BmpInfo) delete []m_BmpInfo;
		m_BmpInfo = (LPBITMAPINFO)new char[sizeof(BITMAPINFO)];
		
		m_BmpInfo->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		m_BmpInfo->bmiHeader.biWidth=m_Width;
		m_BmpInfo->bmiHeader.biHeight=m_Height;
		m_BmpInfo->bmiHeader.biPlanes=1;
		m_BmpInfo->bmiHeader.biBitCount=24;
		m_BmpInfo->bmiHeader.biSizeImage=0;
		m_BmpInfo->bmiHeader.biClrUsed=0;
		m_BmpInfo->bmiHeader.biClrImportant=0;
		m_BmpInfo->bmiHeader.biCompression=BI_RGB;
		m_BmpInfo->bmiHeader.biXPelsPerMeter=0;
		m_BmpInfo->bmiHeader.biYPelsPerMeter=0;

		if(m_BmpImage)	delete [] m_BmpImage;
		m_BmpImage = new char[m_BmpInfo->bmiHeader.biWidth*m_BmpInfo->bmiHeader.biHeight*3];

	}else{					
		if(m_BmpInfo) delete [] m_BmpInfo;
		m_BmpInfo= (LPBITMAPINFO)new char[sizeof(BITMAPINFOHEADER)+
								  (256)*sizeof(RGBQUAD)];
		
		m_BmpInfo->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		m_BmpInfo->bmiHeader.biWidth=m_Width;
		m_BmpInfo->bmiHeader.biHeight=m_Height;
		m_BmpInfo->bmiHeader.biPlanes=1;
		m_BmpInfo->bmiHeader.biBitCount=8;
		m_BmpInfo->bmiHeader.biSizeImage=0;
		m_BmpInfo->bmiHeader.biClrUsed=256;
		m_BmpInfo->bmiHeader.biClrImportant=0;
		m_BmpInfo->bmiHeader.biCompression=BI_RGB;
		m_BmpInfo->bmiHeader.biXPelsPerMeter=0;
		m_BmpInfo->bmiHeader.biYPelsPerMeter=0;

		RGBQUAD				*mp_BmpRgbQuad;
		mp_BmpRgbQuad = m_BmpInfo->bmiColors;

		for(int i=0; i<256; i++ ){
			mp_BmpRgbQuad[i].rgbBlue	= i;	
			mp_BmpRgbQuad[i].rgbGreen	= i;	
			mp_BmpRgbQuad[i].rgbRed		= i;	
			mp_BmpRgbQuad[i].rgbReserved	= 0;	
		}

		if(m_BmpImage)	delete [] m_BmpImage;
		m_BmpImage = new char[m_BmpInfo->bmiHeader.biWidth*m_BmpInfo->bmiHeader.biHeight];
	}

		m_cameraControl->TransferFrame(-1, (unsigned char*)m_BmpImage);

	UpdateMovieRangeWindow(); 

	m_IsDraw=FALSE;	
}

//-----------------------------------------------------------------------------------------------
//	DspPlayCamera();
//-----------------------------------------------------------------------------------------------
void CFastCamMonitorDlg::DspPlayCamera()
{
	int		nRet;
	BOOL	check;
	CString	msg;

	m_IsDraw = TRUE;		

	if( m_nRecFrame <= m_PlayFrameCount)
	{
		::KillTimer(GetSafeHwnd(), TIMER_MODE_PLAY);
		CComboBox* combo3;
		combo3= (CComboBox*)GetDlgItem(IDC_LIVE_IMAGE_DISP);
		combo3->EnableWindow(TRUE);
		combo3= (CComboBox*)GetDlgItem(IDC_LIVE_IMAGE_STOP);
		combo3->EnableWindow(TRUE);
		combo3= (CComboBox*)GetDlgItem(IDC_RECORD_MEMORY);
		combo3->EnableWindow(TRUE);
		combo3 = (CComboBox*)GetDlgItem(IDC_RECORD_SAVE_HD);
		combo3->EnableWindow(TRUE);
		combo3 = (CComboBox*)GetDlgItem(IDC_PRPGRAM_EXIT);
		combo3->EnableWindow(TRUE);
		combo3 = (CComboBox*)GetDlgItem(IDC_PLAY_MEMORY);
		combo3->EnableWindow(TRUE);

		m_disp_status1.SetWindowText("Play End");

		msg = "Play End";
		AfxMessageBox(msg,MB_OK|MB_ICONINFORMATION);

	}
	else{
		m_PlayFrameCount++;
		nRet = m_cameraControl->IsColor((BOOL &)check);
		if(check==TRUE){		
			if(m_BmpInfo==NULL) m_BmpInfo = (LPBITMAPINFO)new char[sizeof(BITMAPINFO)];
			
			m_BmpInfo->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
			m_BmpInfo->bmiHeader.biWidth=m_Width;
			m_BmpInfo->bmiHeader.biHeight=m_Height;
			m_BmpInfo->bmiHeader.biPlanes=1;
			m_BmpInfo->bmiHeader.biBitCount=24;
			m_BmpInfo->bmiHeader.biSizeImage=0;
			m_BmpInfo->bmiHeader.biClrUsed=0;
			m_BmpInfo->bmiHeader.biClrImportant=0;
			m_BmpInfo->bmiHeader.biCompression=BI_RGB;
			m_BmpInfo->bmiHeader.biXPelsPerMeter=0;
			m_BmpInfo->bmiHeader.biYPelsPerMeter=0;

			if(m_BmpImage==NULL)	m_BmpImage = new char[m_BmpInfo->bmiHeader.biWidth*m_BmpInfo->bmiHeader.biHeight*3];

		}else{					
			if(m_BmpInfo==NULL) m_BmpInfo = (LPBITMAPINFO)new char[sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD))/*sizeof(BITMAPINFO)*/];
			
			m_BmpInfo->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
			m_BmpInfo->bmiHeader.biWidth=m_Width;
			m_BmpInfo->bmiHeader.biHeight=m_Height;
			m_BmpInfo->bmiHeader.biPlanes=1;
			m_BmpInfo->bmiHeader.biBitCount=8;
			m_BmpInfo->bmiHeader.biSizeImage=0;
			m_BmpInfo->bmiHeader.biClrUsed=0;
			m_BmpInfo->bmiHeader.biClrImportant=0;
			m_BmpInfo->bmiHeader.biCompression=BI_RGB;
			m_BmpInfo->bmiHeader.biXPelsPerMeter=0;
			m_BmpInfo->bmiHeader.biYPelsPerMeter=0;

			RGBQUAD				*mp_BmpRgbQuad;	
			mp_BmpRgbQuad = m_BmpInfo->bmiColors;


			for(int i=0; i<256; i++ ){
				mp_BmpRgbQuad[i].rgbBlue	= i;	
				mp_BmpRgbQuad[i].rgbGreen	= i;	
				mp_BmpRgbQuad[i].rgbRed		= i;	
				mp_BmpRgbQuad[i].rgbReserved	= 0;	
			}

			if(m_BmpImage==NULL)	m_BmpImage = new char[m_BmpInfo->bmiHeader.biWidth*m_BmpInfo->bmiHeader.biHeight];
		}
	}

	m_cameraControl->TransferFrame(m_PlayFrameCount, (unsigned char*)m_BmpImage);

	char	cWk0[50];

	sprintf(cWk0,"FrameNo.[%d]",m_PlayFrameCount);
	m_disp_status2.SetWindowText(cWk0);

	UpdateMovieRangeWindow(); 
	m_IsDraw = FALSE;	
}

void CFastCamMonitorDlg::OnSelchangeChangeRate() 
{
	int		nSel;
	int		nRet;
	char	ss[10];
	CString msg;

	if(m_Execute_Live==FALSE){
		msg = "changing to a live picture";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	nSel = m_change_rate.GetCurSel();
	m_change_rate.GetLBText(nSel,ss);

	m_nRecordRate = atoi(ss);

	nRet = SetParameter(0);		
	if(nRet<0){
		msg = "error SetRecordRate";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	ClearMovieRangeWindow(); 
	
	UpdateParam();
}

void CFastCamMonitorDlg::OnSelchangeChangeRecord() 
{
	int		nSel;
	int		nSts;
	int		nRecFrame;
	double	dRecFrame;
	CString	msg;
	char	ss[10];

	if(m_Execute_Live==FALSE){
		msg = "changing to a live picture";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	nSts = m_cameraControl->GetMaxFrame((int &)m_nMaxFrame);
	if(nSts==PCC_ERROR_NOERROR){
	
		nSel = m_change_recordtime.GetCurSel();
		m_change_recordtime.GetLBText(nSel,ss);

		m_dRecordTime = atof(ss);

		dRecFrame = m_dRecordTime * m_nRecordRate;
		nRecFrame = (int)dRecFrame;
		
		if(m_nMaxFrame<nRecFrame){
			msg = "shorten Play time";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		}
	}else{
		msg = "error GetMaxFrame";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
	}
}

void CFastCamMonitorDlg::OnLiveImageDisp() 
{

	if(m_Execute_Live==TRUE){
		return;
	}

	int		nSts;	
	int		nRet;
	BOOL	check;
	int		nInterval;
	CString	msg;
	
	nSts = m_cameraControl->OnLive(TRUE);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error OnLive";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}	

	ClearMovieRangeWindow(); 

	CComboBox* combo1 = (CComboBox*)GetDlgItem(IDC_CHANGE_RATE);
	combo1->EnableWindow(TRUE);				
	CComboBox* combo2 = (CComboBox*)GetDlgItem(IDC_CHANGE_RECORD);
	combo2->EnableWindow(TRUE);				

	nRet = m_cameraControl->IsColor((BOOL &)check);
	if(check==TRUE){
		if(m_Width<=512){
			nInterval = 100;	
		}else if(m_Width<=640){
			nInterval = 200;	
		}else if(m_Width<=1280){
			nInterval = 500;	
		}else{
			nInterval = 1000;	
		}
	}else{			
		if(m_Width<=512){
			nInterval = 100;	
		}else if(m_Width<=640){
			nInterval = 200;		
		}else if(m_Width<=1280){
			nInterval = 500;	
		}else{
			nInterval = 1000;	
		}
	}


	::SetTimer(GetSafeHwnd(), TIMER_MODE_LIVE, nInterval, NULL);

	m_disp_status1.SetWindowText("live picture display");
	m_Execute_Live = TRUE;

	UpdateWindow();
}

void CFastCamMonitorDlg::OnLiveImageStop() 
{
	::KillTimer(GetSafeHwnd(), TIMER_MODE_LIVE);

	int		nSts;
	CString	msg;
	nSts = m_cameraControl->OnLive(FALSE);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error OnLive";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	CComboBox* combo1 = (CComboBox*)GetDlgItem(IDC_CHANGE_RATE);
	combo1->EnableWindow(FALSE);				
	CComboBox* combo2 = (CComboBox*)GetDlgItem(IDC_CHANGE_RECORD);
	combo2->EnableWindow(FALSE);				

	m_disp_status1.SetWindowText("Stop Picture");
	m_Execute_Live = FALSE;

	UpdateWindow();
}

void CFastCamMonitorDlg::OnRecordMemory() 
{
	int		nSts;
	CString msg;
	BOOL	check;

	if(m_Execute_Live==FALSE){
		msg = "changing to a live picture";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	m_disp_status1.SetWindowText("Recording");

	::KillTimer(GetSafeHwnd(), TIMER_MODE_LIVE);
	
	m_Execute_Live = FALSE;	

	BeginWaitCursor();	

	nSts = m_cameraControl->IsRecordReady((BOOL &)check);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error IsRecordReady";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}
	
	if(check==FALSE){	
		nSts = m_cameraControl->OnRecordReady(TRUE);
		if(nSts!=PCC_ERROR_NOERROR){
			msg = "error OnRecordReady";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
			EndWaitCursor();	
			return;
		}
	}

	nSts = m_cameraControl->OnRecord(TRUE);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error OnRecord";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}
	
	int wait = GetTickCount();
	while(1){
		m_cameraControl->IsRecord((BOOL &)check);
		if(check==TRUE)
			break;
		if((int)(GetTickCount()-wait)>3000){	
			msg = "error IsRecord";
			AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
			EndWaitCursor();	
			return;
		}
	}

	::SetTimer(GetSafeHwnd(), TIMER_MODE_RECORD, 250, NULL);

	m_Execute_Record = TRUE;
	m_disp_status1.SetWindowText("Recording");

	EndWaitCursor();	
}

void CFastCamMonitorDlg::OnRecordSaveHd() 
{
	int		i;
	int		nSts;
	int		nRet;
	BOOL	check;
	CString	msg;
	char	cWk0[50];
	char	cPath[50];
	SYSTEMTIME	tm;

	if(m_nRecFrame<=0){
		msg = "picture does not exist";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}
	
	nSts = m_cameraControl->OnLive(FALSE);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error OnLive";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	if(m_Execute_Live==TRUE){	
		::KillTimer(GetSafeHwnd(), TIMER_MODE_LIVE);

		m_disp_status1.SetWindowText("Stop Picture");
		m_Execute_Live = FALSE;	
	}

	CComboBox* combo1 = (CComboBox*)GetDlgItem(IDC_CHANGE_RATE);
	combo1->EnableWindow(FALSE);				
	CComboBox* combo2 = (CComboBox*)GetDlgItem(IDC_CHANGE_RECORD);
	combo2->EnableWindow(FALSE);
	UpdateWindow();
	
	BeginWaitCursor();	

	if(m_nRecFrame>0){

		m_disp_status1.SetWindowText("File Save");

		::GetLocalTime(&tm);				
		strcpy(cPath,"c:\\FastCam\\");
		CreateDirectory(cPath,NULL);		
		sprintf(cPath,"c:\\FastCam\\%4.4d%2.2d%2.2d_%2.2d%2.2d%2.2d\\",tm.wYear,tm.wMonth,tm.wDay,tm.wHour,tm.wMinute,tm.wSecond);
		CreateDirectory(cPath,NULL);		
		
		for(i=0; i<m_nRecFrame; i++){

			m_cameraControl->TransferFrame(i, buf);

			sprintf(cPath,"c:\\FastCam\\%4.4d%2.2d%2.2d_%2.2d%2.2d%2.2d\\",tm.wYear,tm.wMonth,tm.wDay,tm.wHour,tm.wMinute,tm.wSecond);
			sprintf(cWk0,"Temp%4.4d.bmp",i+1);
			strcat(cPath,cWk0);

			nRet = m_cameraControl->IsColor((BOOL &)check);
			if(check==TRUE){		
				nSts = WriteBmp24File(cPath, m_Width, m_Height);
				if(nSts<0){
					msg = "error WriteBmp24File";
					AfxMessageBox(msg,MB_OK|MB_ICONWARNING);
					EndWaitCursor();	
					return;
				}
			}else{					
				nSts = WriteBmpFile(cPath, m_Width, m_Height);
				if(nSts<0){
					msg = "error WriteBmpFile";
					AfxMessageBox(msg,MB_OK|MB_ICONWARNING);
					EndWaitCursor();	
					return;
				}
			}

		
			sprintf(cWk0,"FrameNo.[%d]",i+1);
			m_disp_status2.SetWindowText(cWk0);

			Sleep(100);
		}

		m_disp_status1.SetWindowText("File Save end");

		msg = "Save Files";
		AfxMessageBox(msg,MB_OK|MB_ICONINFORMATION);
	}else{
		msg = "picture does not exist";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
	}

	EndWaitCursor();	
}

void CFastCamMonitorDlg::OnPlayMemory() 
{
	int		nSts;
	CString	msg;
	
	if(m_nRecFrame<=0){
		msg = "picture does not exist";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}
	
	nSts = m_cameraControl->OnLive(FALSE);
	if(nSts!=PCC_ERROR_NOERROR){
		msg = "error OnLive";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}

	if(m_Execute_Live==TRUE){	
		::KillTimer(GetSafeHwnd(), TIMER_MODE_LIVE);

		m_disp_status1.SetWindowText("Stop Picture");
		m_Execute_Live = FALSE;	
	}
	
	CComboBox* combo1 = (CComboBox*)GetDlgItem(IDC_CHANGE_RATE);
	combo1->EnableWindow(FALSE);				
	CComboBox* combo2 = (CComboBox*)GetDlgItem(IDC_CHANGE_RECORD);
	combo2->EnableWindow(FALSE);
	UpdateWindow();
	
	BeginWaitCursor();	

	if(m_nRecFrame>0){

		m_disp_status1.SetWindowText("Playing");

		CComboBox* combo3;
		combo3= (CComboBox*)GetDlgItem(IDC_LIVE_IMAGE_DISP);
		combo3->EnableWindow(FALSE);
		combo3= (CComboBox*)GetDlgItem(IDC_LIVE_IMAGE_STOP);
		combo3->EnableWindow(FALSE);
		combo3= (CComboBox*)GetDlgItem(IDC_RECORD_MEMORY);
		combo3->EnableWindow(FALSE);
		combo3 = (CComboBox*)GetDlgItem(IDC_RECORD_SAVE_HD);
		combo3->EnableWindow(FALSE);
		combo3 = (CComboBox*)GetDlgItem(IDC_PRPGRAM_EXIT);
		combo3->EnableWindow(FALSE);
		combo3 = (CComboBox*)GetDlgItem(IDC_PLAY_MEMORY);
		combo3->EnableWindow(FALSE);

		m_PlayFrameCount = 0;
		::SetTimer(GetSafeHwnd(), TIMER_MODE_PLAY, 250, NULL);

	}else{
		msg = "picture does not exist";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
	}

	EndWaitCursor();	
}

void CFastCamMonitorDlg::OnVersionInf() 
{
	CAboutDlg DlgAbout;
	DlgAbout.DoModal();	
}

void CFastCamMonitorDlg::OnPrpgramExit() 
{
	int		nRet;  
	CString msg;

	if(m_Execute_Live==TRUE){
		msg = "perform after suspending a live picture.";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		return;
	}
	
	msg = "Exit Program";
	nRet = AfxMessageBox(msg,MB_YESNO|MB_ICONQUESTION);
	if(nRet==IDYES){
		CDialog::DestroyWindow();
	}
}

int	CFastCamMonitorDlg::GetParameterList(int nNo)
{
	int		i;
	int		nRet;
	int		nSts;
	int		nParamList[MAX_PARAM_LIST];
	CString	ss;
	char	cWk0[20];	

	BeginWaitCursor();

	nRet = -1;	
	switch(nNo){
	case 0:		
			nSts = m_cameraControl->GetRecordRateList((int *)nParamList, MAX_PARAM_LIST);		
			if(nSts==PCC_ERROR_NOERROR){

				//
				m_change_rate.ResetContent();
				for(i=0; i<MAX_PARAM_LIST; i++){
					if(nParamList[i]<1){
						break;
					}
					else{
						sprintf(cWk0,"%d",nParamList[i]);
						m_change_rate.InsertString(-1,cWk0);
					}
				}
				nRet = 0;
			}				
			break;
	case 1:
					
			m_change_recordtime.ResetContent();
			m_change_recordtime.InsertString(-1,"0.5");
			m_change_recordtime.InsertString(-1,"1.0");
			m_change_recordtime.InsertString(-1,"1.5");
			m_change_recordtime.InsertString(-1,"2.0");
			nRet = 0;			
			break;
	}

	EndWaitCursor();	
	
	return(nRet);
}

int	CFastCamMonitorDlg::GetParameter(int nNo)
{
	int		nRet;
	int		nSts;
	int		nRecordRate;
	int		nShutterSpeed;
	int		nTrigMode;
	DWORD	dwResolution;
	int		nGain;

	BeginWaitCursor();	

	nRet = -1;	
	switch(nNo){
	case 0:			
			nSts = m_cameraControl->GetRecordRate((int &)nRecordRate);		
			if(nSts==PCC_ERROR_NOERROR){
				m_nRecordRate = nRecordRate;
				nRet = 0;
			}				
			break;
	case 1:			
			m_dRecordTime = 0.5;
			nRet = 0;			
			break;
	case 2:			
			nSts = m_cameraControl->GetShutterSpeed((int &)nShutterSpeed);		
			if(nSts==PCC_ERROR_NOERROR){
				m_nShutterSpeed = nShutterSpeed;
				nRet = 0;
			}				
			break;
	case 3:			
			nSts = m_cameraControl->GetTriggerMode((int &)nTrigMode);		
			if(nSts==PCC_ERROR_NOERROR){
				m_nTrigMode = nTrigMode;
				nRet = 0;
			}	
			break;
	case 4:			
			nSts = m_cameraControl->GetResolution((DWORD &)dwResolution);		
			if(nSts==PCC_ERROR_NOERROR){
				m_dwResolution = dwResolution;
				nRet = 0;
			}	
			break;
	case 5:			
			nSts = m_cameraControl->GetGainLevel((int &)nGain);		
			if(nSts==PCC_ERROR_NOERROR){
				m_nGain = nGain;
				nRet = 0;
			}	
			break;
	}

	EndWaitCursor();	
	
	return(nRet);
}

int	CFastCamMonitorDlg::SetParameter(int nNo)
{
	int		nRet;
	int		nSts;
	int		nRecordRate;
	int		nShutterSpeed;
	int		nTrigMode;
	DWORD	dwResolution;
	int		nGain;

	nRecordRate		= 0;
	nShutterSpeed	= 0;
	nTrigMode		= 0;
	dwResolution	= 0;
	nGain			= 0;

	BeginWaitCursor();	

	nRet = -1;	
	switch(nNo){
	case 0:			
			nRecordRate = m_nRecordRate;
			nSts = m_cameraControl->SetRecordRate(nRecordRate);		
			if(nSts==PCC_ERROR_NOERROR){
				nRet = 0;
			}				
			break;
	case 1:			
			nRet = 0;			
			break;

	case 2:			
			nShutterSpeed = m_nShutterSpeed;
			nSts = m_cameraControl->SetShutterSpeed(nShutterSpeed);		
			if(nSts==PCC_ERROR_NOERROR){
				nRet = 0;
			}				
			break;
	case 3:			
			nTrigMode = m_nTrigMode;
			nSts = m_cameraControl->SetTriggerMode(nTrigMode);		
			if(nSts==PCC_ERROR_NOERROR){
				nRet = 0;
			}	
			break;
	case 4:			
			dwResolution = m_dwResolution;
			nSts = m_cameraControl->SetResolution(dwResolution);		
			if(nSts==PCC_ERROR_NOERROR){
				nRet = 0;
			}	
			break;
	case 5:			
			nGain = m_nGain;
			nSts = m_cameraControl->SetGainLevel(nGain);		
			if(nSts==PCC_ERROR_NOERROR){
				nRet = 0;
			}	
			break;
	}

	EndWaitCursor();
	
	return(nRet);
}

void CFastCamMonitorDlg::UpdateParam() 
{
	int		nRet;
	int		nWidth;
	int		nHeight;
	int		nParamList[MAX_PARAM_LIST];
	DWORD	dwParamList[MAX_PARAM_LIST];
	char	cWk0[50];
	CString msg;

	BeginWaitCursor();

	nRet = m_cameraControl->GetShutterSpeedList((int *)nParamList, MAX_PARAM_LIST);		
	if(nRet!=PCC_ERROR_NOERROR){
		msg = "error GetShutterSpeedList";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}

	m_nShutterSpeed = nParamList[0];

	nRet = SetParameter(2);
	if(nRet<0){
		msg = "error SetShutterSpeed";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}

	sprintf(cWk0,"1/%d",m_nShutterSpeed);
	m_disp_shutterspeed.SetWindowText(cWk0);

	m_nTrigMode = 0;	
	
	nRet = SetParameter(3);
	if(nRet<0){
		msg = "error SetTriggerMode";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}

	m_disp_trigmode.SetWindowText("START");

	nRet = m_cameraControl->GetResolutionList((DWORD *)dwParamList, MAX_PARAM_LIST);		
	if(nRet!=PCC_ERROR_NOERROR){
		msg = "error GetResolutionList";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}				

	m_dwResolution = dwParamList[0];

	nRet = SetParameter(4);
	if(nRet<0){
		msg = "error SetResolution";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}

	nWidth	= m_dwResolution & 0xffff0000;
	nWidth	= nWidth>>16;
	nHeight = m_dwResolution & 0x0000ffff;

	m_Width  = nWidth;
	m_Height = nHeight;

	sprintf(cWk0,"%dx%d",nWidth,nHeight);
	m_disp_resolution.SetWindowText(cWk0);

	m_nGain = 0;	

	nRet = SetParameter(5);
	if(nRet<0){
		msg = "error SetGainLevel";
		AfxMessageBox(msg,MB_OK|MB_ICONWARNING);	
		EndWaitCursor();	
		return;
	}

	m_disp_gain.SetWindowText("0");

	EndWaitCursor();	
}

void CFastCamMonitorDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if(m_BmpInfo)	delete[] m_BmpInfo;
	if(m_BmpImage)	delete[] m_BmpImage;

	::delete m_cameraControl;
}

int	CFastCamMonitorDlg::WriteBmpFile(char *szFName,int nWidth, int nHeight)
{
	int		i;
	int		x,y;
	int		nCnt;
	int		nPos;
	CFile	file;

	if(!file.Open(szFName, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary)){
		return(-1);
	}

	m_gnSizeFileHdr = sizeof( BITMAPFILEHEADER );
	m_gnSizeInfoHdr = sizeof( BITMAPINFOHEADER );	
	m_gnSizeRgbQuad = sizeof( RGBQUAD )*256;		
	m_gnSizeTop	 = m_gnSizeFileHdr + m_gnSizeInfoHdr + m_gnSizeRgbQuad;
	memcpy( (char *)&m_BmpFileHdr.bfType, "BM", 2 );

	m_gnSizeBmpImage = nWidth * nHeight;		
	m_BmpFileHdr.bfSize = m_gnSizeFileHdr + m_gnSizeInfoHdr + m_gnSizeRgbQuad + m_gnSizeBmpImage;
	m_BmpFileHdr.bfReserved1 = 0;				
	m_BmpFileHdr.bfReserved2 = 0;				
	m_BmpFileHdr.bfOffBits = m_gnSizeTop;		

	file.Write(&m_BmpFileHdr, sizeof(BITMAPFILEHEADER));


	m_BmpInfoHdr.biSize			= 40L;			
	m_BmpInfoHdr.biWidth		= nWidth;		
	m_BmpInfoHdr.biHeight		= nHeight;		
	m_BmpInfoHdr.biPlanes		= 1;			
	m_BmpInfoHdr.biBitCount 	= 8;			
	m_BmpInfoHdr.biCompression	= 0;			
	m_BmpInfoHdr.biSizeImage = m_gnSizeBmpImage;
	m_BmpInfoHdr.biXPelsPerMeter	= 19344;	
	m_BmpInfoHdr.biYPelsPerMeter	= 19344;	
	m_BmpInfoHdr.biClrUsed			= 256;		
	m_BmpInfoHdr.biClrImportant	=   0;			
	file.Write(&m_BmpInfoHdr,sizeof(BITMAPINFOHEADER));
	
	for( i=0; i<256; i++ ){
		m_BmpRgbQuad[i].rgbBlue		= i;
		m_BmpRgbQuad[i].rgbGreen	= i;	
		m_BmpRgbQuad[i].rgbRed		= i;	
		m_BmpRgbQuad[i].rgbReserved	= 0;
	}

	nCnt = sizeof(RGBQUAD)*256;
	file.Write(&m_BmpRgbQuad[0], nCnt);

	for(y=nHeight-1; y>=0; y--){

		nPos = nWidth * y;
		for(x=0; x<nWidth; x++){
			m_gszWkBuf[x] = buf[nPos];
			nPos++;
		}
		file.Write(m_gszWkBuf, nWidth);
	}

	file.Close();

	return(0);
}

int	CFastCamMonitorDlg::WriteBmp24File(char *szFName,int nWidth, int nHeight)
{
	int		x,y;
	int		nPos0;
	int		nPos1;
	CFile	file;

	if(!file.Open(szFName, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary)){
		return(-1);
	}

	m_gnSizeFileHdr = sizeof( BITMAPFILEHEADER );	
	m_gnSizeInfoHdr = sizeof( BITMAPINFOHEADER );	
	m_gnSizeRgbQuad = 0;							
	m_gnSizeTop	 = m_gnSizeFileHdr + m_gnSizeInfoHdr + m_gnSizeRgbQuad;
	memcpy( (char *)&m_BmpFileHdr.bfType, "BM", 2 );

	m_gnSizeBmpImage = nWidth * nHeight * 3;	
	m_BmpFileHdr.bfSize = m_gnSizeFileHdr + m_gnSizeInfoHdr + m_gnSizeRgbQuad + m_gnSizeBmpImage;
	m_BmpFileHdr.bfReserved1 = 0;			
	m_BmpFileHdr.bfReserved2 = 0;				
	m_BmpFileHdr.bfOffBits = m_gnSizeTop;		

	file.Write(&m_BmpFileHdr, sizeof(BITMAPFILEHEADER));

	m_BmpInfoHdr.biSize			= 40L;			
	m_BmpInfoHdr.biWidth		= nWidth;		
	m_BmpInfoHdr.biHeight		= nHeight;		
	m_BmpInfoHdr.biPlanes		= 1;			
	m_BmpInfoHdr.biBitCount 	= 24;		
	m_BmpInfoHdr.biCompression	= 0;			
	m_BmpInfoHdr.biSizeImage = m_gnSizeBmpImage;
	m_BmpInfoHdr.biXPelsPerMeter	= 0;	
	m_BmpInfoHdr.biYPelsPerMeter	= 0;		
	m_BmpInfoHdr.biClrUsed			= 0;		
	m_BmpInfoHdr.biClrImportant		= 0;		

	file.Write(&m_BmpInfoHdr,sizeof(BITMAPINFOHEADER));

	for(y=nHeight-1; y>=0; y--){

		nPos0 = 0;
		nPos1 = nWidth*3*y;
		for(x=0; x<nWidth; x++){
			m_gszWkBuf[nPos0]   = buf[nPos1];
			m_gszWkBuf[nPos0+1] = buf[nPos1+1];
			m_gszWkBuf[nPos0+2] = buf[nPos1+2];
			nPos0 = nPos0+3;
			nPos1 = nPos1+3;
		}
		file.Write(m_gszWkBuf, nWidth*3);
	}

	file.Close();

	return(0);
}





